"use strict";

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _classPrivateMethodInitSpec(obj, privateSet) { _checkPrivateRedeclaration(obj, privateSet); privateSet.add(obj); }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ScrollDirection = void 0;

var isFunction_1 = __importDefault(require("lodash/isFunction"));

var _lastScrollTop = /*#__PURE__*/new WeakMap();

var _setupListeners = /*#__PURE__*/new WeakSet();

var _dispatchEvent = /*#__PURE__*/new WeakSet();

var _determineDirection = /*#__PURE__*/new WeakSet();

var ScrollDirection = /*#__PURE__*/_createClass(
/**
 * start an instance
 * @param {{onlyFor: a callback to determine where to modify classes; threshold: amount in px to take into account }} param0
 */
function ScrollDirection() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$onlyFor = _ref.onlyFor,
      onlyFor = _ref$onlyFor === void 0 ? null : _ref$onlyFor,
      _ref$threshold = _ref.threshold,
      threshold = _ref$threshold === void 0 ? 0 : _ref$threshold,
      _ref$thresholdCallbac = _ref.thresholdCallback,
      thresholdCallback = _ref$thresholdCallbac === void 0 ? null : _ref$thresholdCallbac;

  _classCallCheck(this, ScrollDirection);

  _classPrivateMethodInitSpec(this, _determineDirection);

  _classPrivateMethodInitSpec(this, _dispatchEvent);

  _classPrivateMethodInitSpec(this, _setupListeners);

  _defineProperty(this, "onlyForCallback", null);

  _classPrivateFieldInitSpec(this, _lastScrollTop, {
    writable: true,
    value: 0
  });

  _defineProperty(this, "threshold", 0);

  _defineProperty(this, "thresholdCallback", null);

  this.onlyForCallback = onlyFor;
  this.threshold = threshold;
  this.thresholdCallback = thresholdCallback;

  _classPrivateFieldSet(this, _lastScrollTop, window.pageYOffset || document.documentElement.scrollTop);

  _classPrivateMethodGet(this, _setupListeners, _setupListeners2).call(this);
}
/**
 * setup the scroll event listener
 */
);

function _setupListeners2() {
  var _this = this;

  window.addEventListener('scroll', function () {
    var isValid = !_this.onlyForCallback || _this.onlyForCallback();

    if (!isValid) return;

    _classPrivateMethodGet(_this, _determineDirection, _determineDirection2).call(_this);
  });
}

function _dispatchEvent2(name) {
  requestAnimationFrame(function () {
    window.dispatchEvent(new CustomEvent(name));
  });
}

function _determineDirection2() {
  var body = document.body,
      classList = body.classList;
  var scrollTop = window.pageYOffset || document.documentElement.scrollTop;
  var localThreshold = this.thresholdCallback && (0, isFunction_1["default"])(this.thresholdCallback) ? this.thresholdCallback({
    scrollTop: scrollTop,
    threshold: this.threshold,
    lastScrollTop: _classPrivateFieldGet(this, _lastScrollTop)
  }) : this.threshold;
  if (Math.abs(scrollTop - _classPrivateFieldGet(this, _lastScrollTop)) < localThreshold) return;

  if (scrollTop > _classPrivateFieldGet(this, _lastScrollTop) + localThreshold && !classList.contains('scrolling-down')) {
    classList.add('scrolling-down');
    classList.remove('scrolling-up');

    _classPrivateMethodGet(this, _dispatchEvent, _dispatchEvent2).call(this, 'scrollDirectionChange');
  } else if (scrollTop < _classPrivateFieldGet(this, _lastScrollTop) - localThreshold && !classList.contains('scrolling-up')) {
    classList.add('scrolling-up');
    classList.remove('scrolling-down');

    _classPrivateMethodGet(this, _dispatchEvent, _dispatchEvent2).call(this, 'scrollDirectionChange');
  }

  _classPrivateFieldSet(this, _lastScrollTop, Math.max(scrollTop, 0));
}

exports.ScrollDirection = ScrollDirection;
exports["default"] = ScrollDirection;