function _classPrivateMethodInitSpec(obj, privateSet) { _checkPrivateRedeclaration(obj, privateSet); privateSet.add(obj); }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

import isFunction from 'lodash/isFunction';

var _lastScrollTop = /*#__PURE__*/new WeakMap();

var _setupListeners = /*#__PURE__*/new WeakSet();

var _dispatchEvent = /*#__PURE__*/new WeakSet();

var _determineDirection = /*#__PURE__*/new WeakSet();

export class ScrollDirection {
  /**
   * start an instance
   * @param {{onlyFor: a callback to determine where to modify classes; threshold: amount in px to take into account }} param0
   */
  constructor({
    onlyFor = null,
    threshold = 0,
    thresholdCallback = null
  } = {}) {
    _classPrivateMethodInitSpec(this, _determineDirection);

    _classPrivateMethodInitSpec(this, _dispatchEvent);

    _classPrivateMethodInitSpec(this, _setupListeners);

    _defineProperty(this, "onlyForCallback", null);

    _classPrivateFieldInitSpec(this, _lastScrollTop, {
      writable: true,
      value: 0
    });

    _defineProperty(this, "threshold", 0);

    _defineProperty(this, "thresholdCallback", null);

    this.onlyForCallback = onlyFor;
    this.threshold = threshold;
    this.thresholdCallback = thresholdCallback;

    _classPrivateFieldSet(this, _lastScrollTop, window.pageYOffset || document.documentElement.scrollTop);

    _classPrivateMethodGet(this, _setupListeners, _setupListeners2).call(this);
  }
  /**
   * setup the scroll event listener
   */


}

function _setupListeners2() {
  window.addEventListener('scroll', () => {
    const isValid = !this.onlyForCallback || this.onlyForCallback();
    if (!isValid) return;

    _classPrivateMethodGet(this, _determineDirection, _determineDirection2).call(this);
  });
}

function _dispatchEvent2(name) {
  requestAnimationFrame(() => {
    window.dispatchEvent(new CustomEvent(name));
  });
}

function _determineDirection2() {
  const body = document.body,
        classList = body.classList;
  const scrollTop = window.pageYOffset || document.documentElement.scrollTop;
  const localThreshold = this.thresholdCallback && isFunction(this.thresholdCallback) ? this.thresholdCallback({
    scrollTop,
    threshold: this.threshold,
    lastScrollTop: _classPrivateFieldGet(this, _lastScrollTop)
  }) : this.threshold;
  if (Math.abs(scrollTop - _classPrivateFieldGet(this, _lastScrollTop)) < localThreshold) return;

  if (scrollTop > _classPrivateFieldGet(this, _lastScrollTop) + localThreshold && !classList.contains('scrolling-down')) {
    classList.add('scrolling-down');
    classList.remove('scrolling-up');

    _classPrivateMethodGet(this, _dispatchEvent, _dispatchEvent2).call(this, 'scrollDirectionChange');
  } else if (scrollTop < _classPrivateFieldGet(this, _lastScrollTop) - localThreshold && !classList.contains('scrolling-up')) {
    classList.add('scrolling-up');
    classList.remove('scrolling-down');

    _classPrivateMethodGet(this, _dispatchEvent, _dispatchEvent2).call(this, 'scrollDirectionChange');
  }

  _classPrivateFieldSet(this, _lastScrollTop, Math.max(scrollTop, 0));
}

export default ScrollDirection;