/**
 * ScrollDirection - a class to handle scroll direction classes on body
 *
 * Author: Bogdan Barbu
 * Team: Codingheads (codingheads.com)
 */
interface ScrollDirectionOptions {
    onlyFor?: () => boolean | null;
    threshold?: number;
    thresholdCallback?: Function | null;
}
export declare class ScrollDirection {
    #private;
    onlyForCallback: () => boolean | null;
    threshold: number;
    thresholdCallback?: Function | null;
    /**
     * start an instance
     * @param {{onlyFor: a callback to determine where to modify classes; threshold: amount in px to take into account }} param0
     */
    constructor({ onlyFor, threshold, thresholdCallback, }?: ScrollDirectionOptions);
}
export default ScrollDirection;
