export declare type ScrollOffsetPartSettings = {
    name?: string;
    selectors?: string[];
    elements?: HTMLElement[];
    fixedHeight?: number | false;
    condition?: Function | false;
    resizeCondition?: Function | false;
};
export declare type ScrollOffsetVariable = {
    name: string;
    offsetParts: Array<string | ScrollOffsetPart>;
};
export declare type ScrollOffsetMap = {
    [key: string]: Array<string | ScrollOffsetPart>;
};
export declare type ScrollOffsetSettings = {
    offsetParts?: ScrollOffsetPart[] | ScrollOffsetPartSettings[];
    variables?: ScrollOffsetVariable[] | ScrollOffsetMap;
    extraEvents?: string[];
    registerForHoudini?: boolean;
    useResizeObserver?: boolean;
};
export declare class ScrollOffsetPart {
    #private;
    constructor({ name, selectors, elements, fixedHeight, condition, resizeCondition, }: ScrollOffsetPartSettings);
    get name(): string;
    get totalHeight(): number;
    get isValid(): boolean;
    get elements(): HTMLElement[];
    calculate: () => this;
    calculateResizeConditions: () => boolean;
}
/**!
 * ScrollOffset - a class to handle add css variables to the body element,
 * with the value of the "header" parts that are visible
 * so that we can adjust scroll positions etc. based on it
 *
 * Author: Bogdan Barbu
 * Team: Codingheads (codingheads.com)
 */
export declare class ScrollOffset {
    #private;
    /**
     * setup the conditions
     */
    constructor({ offsetParts, variables, registerForHoudini, useResizeObserver, extraEvents, }?: ScrollOffsetSettings);
}
export default ScrollOffset;
